# Generated by sila2.code_generator; sila2.__version__: 0.10.5
from __future__ import annotations

import traceback
from datetime import timedelta
from typing import TYPE_CHECKING
import logging

from sila2.server import MetadataDict, ObservableCommandInstance

from ..generated.temperaturecontroller import ControlTemperature_Responses, TemperatureControllerBase

if TYPE_CHECKING:
    from ..server import Server

logger = logging.getLogger(__name__)


class TemperatureControllerImpl(TemperatureControllerBase):
    def __init__(self, parent_server: Server) -> None:
        super().__init__(parent_server=parent_server)

        self.hwif = parent_server.hardware_interface

        # Default lifetime of observable command instances. Possible values:
        # None: Command instance is valid and stored in memory until server shutdown
        # datetime.timedelta: Command instance is deleted after this duration, can be increased during command runtime
        self.ControlTemperature_default_lifetime_of_execution = timedelta(minutes=30)

        self.run_periodically(self._keep_temperature_up_to_date, delay_seconds=5)


    def _keep_temperature_up_to_date(self):
        try:
            # random temperature for testing (float between 0 and 100)
            
            curr_t, target_t = (self.hwif.current_temperature, 66.6) #self.com.temperature
            self.current_temperature = curr_t
            print(f"**** updating temperature - curr: {curr_t}  target: {target_t}\n")
            self.update_CurrentTemperature(curr_t)
            
        except Exception as ex:
            logging.warning(
                f"Temperature update for thermometer failed: {ex} {traceback.print_exc()}"
            )
            pass

    def ControlTemperature(
        self, TargetTemperature: float, *, metadata: MetadataDict, instance: ObservableCommandInstance
    ) -> ControlTemperature_Responses:
        # set execution status from `waiting` to `running`
        instance.begin_execution()

        raise NotImplementedError  # TODO
